﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.LightSwitch;
using Microsoft.LightSwitch.Security.Server;
namespace LightSwitchApplication
{
    public partial class ApplicationDataService
    {
        partial void SchoolBooks_Validate(SchoolBook entity, EntitySetValidationResultsBuilder results)
        {
            if (Application.User.HasPermission(Permissions.DistrictAccess))
                return;

            int? LoggedInSchoolEmployeeSchoolId = (from emp in DataWorkspace.ApplicationData.SchoolEmployees
                                            where emp.User == Application.Current.User.Name
                                            select emp).FirstOrDefault().School.Id;
            if (LoggedInSchoolEmployeeSchoolId.HasValue == false)
            {
                results.AddEntityError("Denied");
                return;
            }

            if (entity.School.Id != LoggedInSchoolEmployeeSchoolId)
            {
                results.AddEntityError(string.Format("Employee {0} belongs to {1}, book belongs to {2}",
                                                        "Unknown", "Unknown",
                                                        entity.School.Name));
                return;
            }

        }

        partial void LoggedInEmployeeSchoolBooks_PreprocessQuery(ref IQueryable<SchoolBook> query)
        {
            var LoggedInEmployee = (from entity in DataWorkspace.ApplicationData.SchoolEmployees
                                            where entity.User == Application.Current.User.Name
                                            select entity).FirstOrDefault();

            query = LoggedInEmployee != null ?
                from entity in query
                where entity.School.Id == LoggedInEmployee.School.Id
                select entity : null;

        }

        partial void SchoolBooks_All_PreprocessQuery(ref IQueryable<SchoolBook> query)
        {
            if (Application.Current.User.HasPermission(Permissions.DistrictAccess))
                return;

            var LoggedInEmployee = (from entity in DataWorkspace.ApplicationData.SchoolEmployees
                                    where entity.User == Application.Current.User.Name
                                    select entity).FirstOrDefault();

            query = LoggedInEmployee != null ?
                from entity in query
                where entity.School.Id == LoggedInEmployee.School.Id
                select entity : null;

        }

    }
}
